/*

 qerror2_c

 Print a QDOS/standard error message with qualification string

 Date		Author		Comments
 ----		------		--------
 23/09/1991	P.J. Taylor	Original.
 23/09/1991	P.J. Taylor	Amended.

 1.04
 ----
 07/03/1998	A.D.Ives	Source code reformatted.
				Enclose command string in quotes not
				angle brackets.

*/

#include <errno.h>
#include <qdos.h>
#include <debug.h>
#include <string.h>
#include "libpjt.h"

void qerror2(char *msg, char *name) {

  /* msg	Error message to be output	*/
  /* name	Name of corresponding command	*/
  
  char buff[81] ;	/* Temp area to hold combined message	*/
  long o_oserr ,	/* Place to save _oserr 		*/
       o_errno ;	/* Place to save errno			*/

  if ( msg != NULL ) {
    o_oserr= _oserr ;
    o_errno= errno ;
    strncpy(buff, msg, 80) ;

    if ( name != NULL && strlen(buff) + strlen(name) + 3 < 81 ) {
      strcat(buff, " \"") ;
      strcat(buff, name) ;
      strcat(buff, "\"");
    }
    _oserr = o_oserr ;
    errno = o_errno ;
    qerror(buff) ;
  }
  else
    qerror(NULL) ;
}
